package ProcessStepMngr;

#use strict;
use warnings;
use diagnostics;

use ChIPSeqPipeline_input;
#require 'ChIPSeqPipeline_input.pl';
use step_getSampleFilesScp;
use ChIPSeqPipeline_processStep;



sub new {
  my $self  = {};
  $self->{STUDY} = undef;
  $self->{GENERAL_PARAMS} = undef;
  $self->{PROCESS_STATUS} = "START";
  $self->{PROCESS_STEP_HISTORY} = [];
  $self->{REF_HASH_STEP_SEQ} = undef;###Key = stepName_status. Val = nextStepName.
  $self->{IS_PROCESSED_STEP_SEQ} = "0";### 1 = already processed, do not process now. 0 = not yet processed or a new processing is in order. Process now.
  $self->{CUR_PROCESS_STEP} = undef; ### Process Step Object
  bless($self); 
  return $self;
}

sub generalParams{
  my $self = shift;
  if (@_) { 
    $self->{GENERAL_PARAMS} = shift;
  }
  return $self->{GENERAL_PARAMS};
}

sub study {
  my $self = shift;
  if (@_) { $self->{STUDY} = shift }
  return $self->{STUDY};
}
sub processStatus {
  my $self = shift;
  if (@_) { $self->{PROCESS_STATUS} = shift }
  return $self->{PROCESS_STATUS};
}
sub processStepHistory {
  my $self = shift;
  if(@_){ push@{ $self->{PROCESS_STEP_HISTORY} }, @_ }
  return @{ $self->{PROCESS_STEP_HISTORY} };
}
sub curProcessStep {
  my $self = shift;
 if (@_) { $self->{CUR_PROCESS_STEP} = shift }
  return $self->{CUR_PROCESS_STEP};
}

sub getGeneralParam{
  my $self = shift;
  my $refHash = $self->{GENERAL_PARAMS};
  my $key = shift;
  return $$refHash{ $key };
}

sub getStepSeq{
  my $self = shift;
  my $refHash = $self->refHashStepSeq();
  my $key = shift;
  return $$refHash{ $key };
}

sub continueProcess{
  my $self = shift; 
  $self -> processStepSeq();
  my $nextProcessStep = $self -> nextProcessStep();
  $self -> curProcessStep( $nextProcessStep );
  $self -> curProcessStep -> operate();
}

sub isProcessStepSeq{
  my $self = shift;
  if (@_) { $self->{IS_PROCESSED_STEP_SEQ} = shift }
  return $self->{IS_PROCESSED_STEP_SEQ};
}

sub refHashStepSeq{
  my $self = shift;
  if (@_) { $self->{REF_HASH_STEP_SEQ} = shift }
  return $self->{REF_HASH_STEP_SEQ};
}

sub processStepSeq{
  my $self = shift;  
  if( ( $self->isProcessStepSeq() ) == 1 ){ return; }
  my $stepSeqFile = $self -> getGeneralParam( "PROCESS_STEP_SEQ_FILE" );
  if(!defined($stepSeqFile) ){ print"No step seq file was found in ProcessStepSeq\n"; return; }
  #print"stepSeqFile [$stepSeqFile]\n";
  my $tmpFile = "tmpFile.txt";
  ### Replace first tab with underscore (CUR_STEP STATUS -> CUR_STEP_STATUS).
  system("cp $stepSeqFile $tmpFile");
  system("perl  -pi -e 's/\t/_/' $tmpFile");###Not a global replacement
  my $currDir = `pwd`; chomp $currDir;
  $tmpFile = "$currDir". "/"."$tmpFile";
  #print"tmpFile [$tmpFile]\n";
  my $inputObjct = Input -> new;
  $self->{REF_HASH_STEP_SEQ} = {};
  $inputObjct -> hashParams( $tmpFile, $self->{REF_HASH_STEP_SEQ}  );###From input.pm
  #print"----- step seq: ----------\n";
  #my $refHash = 
  foreach my $key ( sort( keys(%{$self->refHashStepSeq()}) ) ){ my $val = $self->getStepSeq( $key );  print"[$key] -> [$val]\n";  }
  #print"----- End step seq ----------\n";
  ### Remove temporary file
  system("rm $tmpFile");
  $self->{IS_PROCESSED_STEP_SEQ} = 1;
}

sub nextProcessStep{
  ### Gets current processing step. If undefined start with first step (start + done) 
  ### Otherwise, get the process step name and status and return an object of the next process step
  ### Status can be: DONE, RUNNING, PARTIAL, FAILED.
  my $self = shift;
  my $curStepName; my $curStepStatus;
  ### Assign step name and status. First step has special treatment.
  if( (!(defined( $self -> curProcessStep() )) ) ){ $curStepName = "Start";  $curStepStatus = "DONE"; }
  else{
    $curStepName = ($self -> curProcessStep()) -> name();
    $curStepStatus = ($self -> curProcessStep()) -> status();
  }
  ###Search for next step based on current step name and status:
  my $stepKey = "$curStepName"."_"."$curStepStatus";
  print"stepKey [$stepKey]\n";
  #foreach my $key ( sort( keys(%hashStepSeq) ) ){ my $val = $self->getStepSeq($key); print"[$key] -> [$val]\n"; }
  my $nextProcessStep = $self -> getStepSeq( $stepKey );
  if( !(defined($nextProcessStep) ) ){ print"Error: No $stepKey package is listed as a next step in process step sequence file\n";  return; }
  print"nextProcessStep [$nextProcessStep]\n"; 
  my $nextStepbjct =  new {$nextProcessStep}("name");
  #my $objct = new {$string}("Inbal", "wow", 111); 
  #my $nextStepbjct =  new {$nextProcessStep}(); #${$nextProcessStep} -> new;
  #my $nextStepbjct =  new {$nextProcessStep};
  #my $nextStepbjct =  {$nextProcessStep}->new;
  ###Example: my $objct = new {$string}("yes", "wow", 111); 
  exit;
  #$nextStepbjct -> print();
  #my $objct = GetSampleFilesScp -> new ;
  #$objct ->print();
  #return $nextStepbjct;
}

sub print{
  my $self = shift;
  print"~~~~~~~~~~ Process Step Manager ~~~~~~~~~~\n";
}
1;
