use strict;
use warnings;
use diagnostics;

use ChIPSeqPipeline_input;
#require 'ChIPSeqPipeline_input.pl';
use step_getSampleFilesScp;
use ChIPSeqPipeline_processStep;

package ProcessStepMngr;

sub new {
  my $self  = {};
  $self->{STUDY} = undef;
  $self->{GENERAL_PARAMS} = undef;
  $self->{PROCESS_STATUS} = "START";
  $self->{PROCESS_STEP_HISTORY} = [];
  $self->{CUR_PROCESS_STEP} = undef; ### Process Step Object
  bless($self); 
  return $self;
}

sub generalParams{
  my $self = shift;
  if (@_) { $self->{GENERAL_PARAMS} = shift }
  return $self->{GENERAL_PARAMS};
}

sub study {
  my $self = shift;
  if (@_) { $self->{STUDY} = shift }
  return $self->{STUDY};
}
sub processStatus {
  my $self = shift;
  if (@_) { $self->{PROCESS_STATUS} = shift }
  return $self->{PROCESS_STATUS};
}
sub processStepHistory {
  my $self = shift;
  if(@_){ push@{ $self->{PROCESS_STEP_HISTORY} }, @_ }
  return @{ $self->{PROCESS_STEP_HISTORY} };
}
sub curProcessStep {
  my $self = shift;
 if (@_) { $self->{CUR_PROCESS_STEP} = shift }
  return $self->{CUR_PROCESS_STEP};
}

sub getGeneralParam{
  my $self = shift;
  my $refHash = $self->{GENERAL_PARAMS};
  my $key = shift;
  return $$refHash{ $key };
}


sub continueProcess{
  my $self = shift; 
  my $nextProcessStep = $self -> nextProcessStep();
  $self -> curProcessStep( $nextProcessStep );
  $self -> curProcessStep -> operate();
}

sub ProcessStepSeq

sub nextProcessStep{
  ### Gets current processing step. If undefined start with first step (get sample files scp) 
  ### Otherwise, get the process step name and status and return an object of the next process step
  ### Status can be: DONE, RUNNING, PARTIAL, FAILED.
  my $self = shift;
  my %hashStepSeq = ();###Key = stepName_status. Val = nextStepName.
  my $stepSeqFile = $self -> getGeneralParam( "PROCESS_STEP_SEQ_FILE" );
  #print"stepSeqFile [$stepSeqFile]\n";
  my $tmpFile = "tmpFile.txt";
  ### Replace first tab with underscore (CUR_STEP STATUS -> CUR_STEP_STATUS).
  system("cp $stepSeqFile $tmpFile");
  system("perl  -pi -e 's/\t/_/' $tmpFile");###Not a global replacement
  my $currDir = `pwd`; chomp $currDir;
  $tmpFile = "$currDir". "/"."$tmpFile";
  print"tmpFile [$tmpFile]\n";
  my $inputObjct = Input -> new;
  $inputObjct -> hashParams( $tmpFile, \%hashStepSeq  );###From input.pm
  my $curStepName; my $curStepStatus;
  ### Assign step name and status. First step has special treatment.
  if( (!(defined( $self -> curProcessStep() )) ) ){ $curStepName = "Start";  $curStepStatus = "DONE"; }
  else{
    $curStepName = ($self -> curProcessStep()) -> name();
    $curStepStatus = ($self -> curProcessStep()) -> status();
  }
  ###Search for next step based on current step name and status:
  my $stepKey = "$curStepName"."_"."$curStepStatus";
  print"stepKey [$stepKey]\n";
  #foreach my $key ( sort( keys(%hashStepSeq) ) ){ my $val = $hashStepSeq{ $key }; print"[$key] -> [$val]\n"; }
  my $nextProcessStep = $hashStepSeq{ $stepKey };
  if( !(defined($nextProcessStep) ) ){ print"Error: No $nextProcessStep package is listed as a next step in process step sequence file\n";  return; }
  print"nextProcessStep [$nextProcessStep]\n"; 
  #my $objct = ProcessStep -> new ;
  my $objct = GetSampleFilesScp -> new ;
  $objct ->print();
  ### Remove temporary file
  system("rm $tmpFile");
  return $nextStepbjct;
}

sub print{
  my $self = shift;
  print"~~~~~~~~~~ Process Step Manager ~~~~~~~~~~\n";
}
1;
