#use strict;
use warnings;
use diagnostics;

use ChIPSeqPipeline_file;

package Sample;

sub new {
  my $self  = {};
  $self->{NAME} = undef;
  $self->{TITLE}  = undef;
  $self->{PLATFORM}  = undef;
  $self->{DESC}  = undef;
  $self->{DATA_FILES} = [];
  $self ->{GROUPS} = [];
  bless($self); 
  return $self;
}

sub name{
  my $self = shift;
  if (@_) { $self->{NAME}  = shift; }
  return $self->{NAME};
}
sub title{
  my $self = shift;
  if (@_) { $self->{TITLE}  = shift; }
  return $self->{TITLE};
}
sub platform{
  my $self = shift;
  if (@_) { $self->{PLATFORM}  = shift; }
  return $self->{PLATFORM};
}
sub desc{
  my $self = shift;
  if (@_) { $self->{DESC}  = shift; }
  #my $d = $self->{DESC}; print"sample desc $d\n";
  return $self->{DESC};
}
sub dataFiles{
  my $self = shift;
  if(@_){ push@{ $self->{DATA_FILES} }, @_ }
  return @{ $self->{DATA_FILES} };
}
sub groups{
  my $self = shift;
  if(@_){ push@{ $self->{GROUPS} }, @_ }
  return @{ $self->{GROUPS} };
}

sub groupsNum{
  my $self = shift;
  return ( $#{ $self->{GROUPS} } +1 );
}
sub dataFilesNum{
  my $self = shift;
  return ( $#{ $self->{DATA_FILES} } +1 );
}
sub addGroup{
  ### Add a group object to sample's groups array if group is new.
  ### Groups are compared using the isEqual subroutine of the Group package.
  my $self = shift;
  my($groupObjct) = @_;
  if( ( $self -> isNewGroup( $groupObjct ) ) ==1 ){
    $self->groups( $groupObjct );
    #print"add group to sampe\n";
    return 1;
  }
  #print"DIDN'T add group to sampe\n";
  return 0;
}

sub isNewGroup {
  ### Returns 1 if group is new and zero otherwise.
  my $self = shift;
  my($groupObjct) = @_;
  foreach my $groupObjct ( $self -> groups() ){
    if( ( $self->isEqual( $groupObjct ) ) == 1 ){ return 0; }
  }
  return 1;
}

sub isEqual {
  ### Compare two samplep objects to determine similarity.
  ### Comparison is based on group name only (at this point).
  my $self  = shift;
  my($sampleObjct) = @_;
  if( $self -> name() eq $sampleObjct -> name() ){ return 1; }
  return 0;
}

sub getSamplesDirPath{
  my $self  = shift;
  my $groupsNum = $self -> groupsNum();
  if( $groupsNum <= 0 ){ my $name = $self -> name(); print "Error: getSamplesDirPath can only work after group has been assigned. Sample $name has no groups\n"; return;}
  my @groups = @{$self->{GROUPS}};
  my $firstGroup = $groups[0];
  my $study = $firstGroup -> study();
  return  $study -> samplesDirPath();
}

sub detectDataFiles {
  my $self  = shift;
  my $samplesDir = $self -> getSamplesDirPath();
  print"samplesDir $samplesDir \n";
  
}

sub print {
  my $self  = shift;
 my $name = $self -> name(); my $dataFilesNum = $self -> dataFilesNum();
  print"\t\t\t\t~~~~~~~~~~ Sample $name has $dataFilesNum data files  ~~~~~~~~~~~\n";
  #foreach my $sample ( $self -> samples() ){
  #  $sample->print();
  #}
}

1;
